commit b064cc0ef055fdcb91c971234b756e494f64e347
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Tue Dec 9 10:59:13 2025 +0000

    DMARC: rework module API

diff --git a/src/src/acl.c b/src/src/acl.c
index b3c45668a..63478ca7d 100644
--- a/src/src/acl.c
+++ b/src/src/acl.c
@@ -3939,25 +3939,20 @@ for (; cb; cb = cb->next)
       /* See comment on ACLC_SPF wrt. coding issues */
       {
       misc_module_info * mi = misc_mod_find(US"dmarc", &log_message);
-      typedef const uschar * (*efn_t)(void);
-      const uschar * expanded_query;
+      typedef int (*pfn_t)(void);
+      typedef int (*mfn_t)(const uschar * const *);
 
       if (!mi)
-	{ rc = DEFER; break; }			/* shouldn't happen */
-
-      if (!f.dmarc_has_been_checked)		/* only once per message */
+	rc = DEFER;				/* shouldn't happen */
+      else
 	{
-	typedef int (*pfn_t)(void);
-	(void) (((pfn_t *) mi->functions)[DMARC_PROCESS]) ();
-	f.dmarc_has_been_checked = TRUE;
+	if (!f.dmarc_has_been_checked)		/* only once per message */
+	  {
+	  (void) (((pfn_t *) mi->functions)[DMARC_PROCESS]) ();
+	  f.dmarc_has_been_checked = TRUE;
+	  }
+	rc = (((mfn_t *) mi->functions)[DMARC_RESULT_INLIST]) (&arg);
 	}
-
-      /* used long way of dmarc_exim_expand_query() in case we need more
-      view into the process in the future. */
-
-      expanded_query = (((efn_t *) mi->functions)[DMARC_EXPAND_QUERY]) ();
-      rc = match_isinlist(expanded_query,
-			  &arg, 0, NULL, NULL, MCL_STRING, TRUE, NULL);
       }
       break;
 #endif
diff --git a/src/src/globals.c b/src/src/globals.c
index 610c72909..6c8e8ec05 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -838,6 +838,7 @@ volatile sig_atomic_t had_command_sigterm = 0;
 volatile sig_atomic_t had_data_timeout    = 0;
 volatile sig_atomic_t had_data_sigint     = 0;
 const uschar *headers_charset  = US HEADERS_CHARSET;
+const uschar *header_from      = NULL;		/* mainly for dmarc */
 int     header_insert_maxlen   = 64 * 1024;
 header_line  *header_last      = NULL;
 header_line  *header_list      = NULL;
diff --git a/src/src/globals.h b/src/src/globals.h
index 1c133f5ea..977107f58 100644
--- a/src/src/globals.h
+++ b/src/src/globals.h
@@ -633,6 +633,7 @@ extern volatile sig_atomic_t had_command_timeout;   /* Alarm sighandler called *
 extern volatile sig_atomic_t had_command_sigterm;   /* TERM  sighandler called */
 extern volatile sig_atomic_t had_data_timeout;      /* Alarm sighandler called */
 extern volatile sig_atomic_t had_data_sigint;       /* TERM/INT  sighandler called */
+extern const uschar *header_from;      /* Text of the From: header */
 extern int     header_insert_maxlen;   /* Max for inserting headers */
 extern int     header_maxsize;         /* Max total length for header */
 extern int     header_line_maxsize;    /* Max for an individual line */
diff --git a/src/src/miscmods/dmarc.c b/src/src/miscmods/dmarc.c
index a18100c81..5a5ea7398 100644
--- a/src/src/miscmods/dmarc.c
+++ b/src/src/miscmods/dmarc.c
@@ -161,7 +161,7 @@ is locally generated and relying on fixups to add it.  Just skip
 the entire DMARC system if we can't find a From: header....or if
 there was a previous error.  */
 
-if (!dmarc_from_header)
+if (!header_from)
   {
   DEBUG(D_receive) debug_printf_indent("DMARC: no From: header\n");
   dmarc_abort = TRUE;
@@ -173,10 +173,10 @@ else if (!dmarc_abort)
   int dummy, domain;
 
   f.parse_allow_group = TRUE;
-  end_addr = parse_find_address_end(dmarc_from_header, FALSE);
+  end_addr = parse_find_address_end(header_from, FALSE);
   s = *end_addr
-      ? string_copyn(dmarc_from_header, end_addr - dmarc_from_header)
-      : dmarc_from_header;
+      ? string_copyn(header_from, end_addr - header_from)
+      : header_from;
   if ((dmarc_header_from_sender = parse_extract_address(s, &errormsg,
 			      &dummy, &dummy, &domain, FALSE)))
     dmarc_header_from_sender += domain;
@@ -193,7 +193,7 @@ else if (!dmarc_abort)
     {
     log_write(0, LOG_MAIN|LOG_PANIC,
 	      "failure to store header From: in DMARC: %s, header was '%s'",
-	      opendmarc_policy_status_to_str(libdm_status), dmarc_from_header);
+	      opendmarc_policy_status_to_str(libdm_status), header_from);
     dmarc_abort = TRUE;
     }
   }
@@ -335,7 +335,7 @@ The EDITME provides a DMARC_API variable */
       DEBUG(D_receive)
 	debug_printf_indent("DMARC skipping (%s), unsure what to do with %s",
 		      opendmarc_policy_status_to_str(libdm_status),
-		      dmarc_from_header);
+		      header_from);
       has_dmarc_record = FALSE;
       break;
     }
@@ -458,14 +458,17 @@ dmarc_exim_expand_defaults(void)
 return f.dmarc_disable_verify ?  US"off" : US"none";
 }
 
-/*API*/
-const uschar *
-dmarc_exim_expand_query(void)
+/*API
+Check result against list.  Return OK/FAIL/DEFER.
+*/
+int
+dmarc_result_inlist(const uschar * const * listp)
 {
-if (f.dmarc_disable_verify || !dmarc_pctx)
-  return dmarc_exim_expand_defaults();
-
-return dmarc_status;
+const uschar * res =
+  f.dmarc_disable_verify || !dmarc_pctx
+  ? dmarc_exim_expand_defaults()
+  : dmarc_status;
+return match_isinlist(res, listp, 0, NULL, NULL, MCL_STRING, TRUE, NULL);
 }
 
 
diff --git a/src/src/miscmods/dmarc.h b/src/src/miscmods/dmarc.h
index 6f8c456dd..fe3138cf2 100644
--- a/src/src/miscmods/dmarc.h
+++ b/src/src/miscmods/dmarc.h
@@ -120,7 +120,6 @@
 extern BOOL dmarc_abort;
 extern uschar * dmarc_header_from_sender;
 extern uschar * dmarc_pass_fail;
-extern const uschar * dmarc_from_header;
 extern const misc_module_info * dmarc_dkim_mod_info;
 extern const misc_module_info * dmarc_spf_mod_info;
 extern int dmarc_spf_ares_result;
diff --git a/src/src/miscmods/dmarc_api.h b/src/src/miscmods/dmarc_api.h
index 54b1630a6..e99b45804 100644
--- a/src/src/miscmods/dmarc_api.h
+++ b/src/src/miscmods/dmarc_api.h
@@ -12,5 +12,4 @@
 /* Function table entry numbers */
 
 #define	DMARC_PROCESS		0
-#define DMARC_EXPAND_QUERY	1
-#define DMARC_STORE_FROMHDR	2
+#define DMARC_RESULT_INLIST	1
diff --git a/src/src/miscmods/dmarc_common.c b/src/src/miscmods/dmarc_common.c
index 1669d8400..35b832c59 100644
--- a/src/src/miscmods/dmarc_common.c
+++ b/src/src/miscmods/dmarc_common.c
@@ -15,7 +15,7 @@ extern BOOL		dmarc_local_init(void);
 extern void		dmarc_local_msg_init(void);
 extern gstring *	dmarc_version_report(gstring *);
 extern int		dmarc_process(void);
-extern const uschar *	dmarc_exim_expand_query(void);
+extern const uschar *	dmarc_result_inlist(const uschar * const *);
 
 
 /* Other modules needed for services */
@@ -26,7 +26,6 @@ const misc_module_info * dmarc_arc_mod_info;
 /* Working data */
 BOOL		dmarc_abort;
 uschar *	dmarc_pass_fail;	/* for authres */
-const uschar *	dmarc_from_header;
 uschar *	dmarc_header_from_sender;
 
 /* results */
@@ -96,7 +95,6 @@ dmarc_msg_init(void)
 multiple messages in one connection. */
 
 f.dmarc_has_been_checked = FALSE;
-dmarc_from_header	 = NULL;
 dmarc_header_from_sender = NULL;
 dmarc_spf_ares_result  = ARES_RESULT_UNDEFINED;
 dmarc_status       = US"none";
@@ -140,18 +138,6 @@ dmarc_domain_policy = dmarc_status = dmarc_status_text =
 }
 
 
-/* API: dmarc_store_data stores the header data so that subsequent dmarc_process
-can access the data.  Cleared by msg_init.
-Called after the entire message has been received, with the From: header. */
-
-static void
-dmarc_store_fromhdr(const uschar * hdr)
-{
-/* No debug output because would change every test debug output */
-dmarc_from_header = hdr;
-}
-
-
 /* Accept an error_block struct, initialize if empty, parse to the
 end, and append the two strings passed to it.  Used for adding
 variable amounts of value:pair data to the forensic emails. */
@@ -501,8 +487,7 @@ static optionlist dmarc_options[] = {
 
 static void * dmarc_functions[] = {
   [DMARC_PROCESS] =	(void *) dmarc_process,
-  [DMARC_EXPAND_QUERY] = (void *) dmarc_exim_expand_query,
-  [DMARC_STORE_FROMHDR] = (void *) dmarc_store_fromhdr,
+  [DMARC_RESULT_INLIST] = (void *) dmarc_result_inlist,
 };
 
 /* dmarc_forensic_sender is provided for visibility of the the option setting
diff --git a/src/src/miscmods/dmarc_native.c b/src/src/miscmods/dmarc_native.c
index f0c91868b..96628dee1 100644
--- a/src/src/miscmods/dmarc_native.c
+++ b/src/src/miscmods/dmarc_native.c
@@ -310,7 +310,7 @@ is locally generated and relying on fixups to add it.  Just skip
 the entire DMARC system if we can't find a From: header....or if
 there was a previous error.  */
 
-if (!dmarc_from_header)
+if (!header_from)
   {
   DEBUG(D_receive) debug_printf_indent("DMARC: no From: header\n");
   dmarc_abort = TRUE;
@@ -323,10 +323,10 @@ else
   int dummy, domain;
 
   f.parse_allow_group = TRUE;
-  end_addr = parse_find_address_end(dmarc_from_header, FALSE);
+  end_addr = parse_find_address_end(header_from, FALSE);
   s = *end_addr
-      ? string_copyn(dmarc_from_header, end_addr - dmarc_from_header)
-      : dmarc_from_header;
+      ? string_copyn(header_from, end_addr - header_from)
+      : header_from;
   if ((dmarc_header_from_sender = parse_extract_address(s, &errormsg,
 			      &dummy, &dummy, &domain, FALSE)))
     dmarc_header_from_sender += domain;
@@ -668,14 +668,15 @@ dmarc_exim_expand_defaults(void)
 return f.dmarc_disable_verify ?  US"off" : US"none";
 }
 
-/*API*/
-const uschar *
-dmarc_exim_expand_query(void)
+/*API
+Check result against list.  Return OK/FAIL/DEFER.
+*/
+int
+dmarc_result_inlist(const uschar * const * listp)
 {
-if (f.dmarc_disable_verify )            // || !dmarc_pctx)
-  return dmarc_exim_expand_defaults();
-
-return dmarc_status;
+const uschar * res =
+  f.dmarc_disable_verify ? dmarc_exim_expand_defaults() : dmarc_status;
+return match_isinlist(res, listp, 0, NULL, NULL, MCL_STRING, TRUE, NULL);
 }
 
 
diff --git a/src/src/receive.c b/src/src/receive.c
index 7827d0288..f1833c5a0 100644
--- a/src/src/receive.c
+++ b/src/src/receive.c
@@ -1732,47 +1732,36 @@ not. */
 BOOL
 receive_msg(BOOL extract_recip)
 {
-int  rc = FAIL;
-int  msg_size = 0;
-int  process_info_len = Ustrlen(process_info);
+int  rc = FAIL, msg_size = 0, process_info_len = Ustrlen(process_info);
+int  header_size = 256, had_zero = 0, prevlines_length = 0, ptr = 0;
+
 int  error_rc = error_handling == ERRORS_SENDER
 	? errors_sender_rc : EXIT_FAILURE;
-int  header_size = 256;
-int  had_zero = 0;
-int  prevlines_length = 0;
 const int id_resolution = BASE_62 == 62 && !host_number_string ? 1
   : BASE_62 != 62 && host_number_string ? 4
   : 2;
 
-int ptr = 0;
-
-BOOL contains_resent_headers = FALSE;
-BOOL extracted_ignored = FALSE;
-BOOL first_line_ended_crlf = TRUE_UNSET;
-BOOL smtp_yield = TRUE;
-BOOL yield = FALSE;
+BOOL contains_resent_headers = FALSE, extracted_ignored = FALSE;
+BOOL first_line_ended_crlf = TRUE_UNSET, smtp_yield = TRUE, yield = FALSE;
 
 BOOL resents_exist = FALSE;
-uschar *resent_prefix = US"";
-uschar *blackholed_by = NULL;
-uschar *blackhole_log_msg = US"";
+uschar * resent_prefix = US"", * blackholed_by = NULL;
+uschar * blackhole_log_msg = US"";
 enum {NOT_TRIED, TMP_REJ, PERM_REJ, ACCEPTED} cutthrough_done = NOT_TRIED;
 
 flock_t lock_data;
-error_block *bad_addresses = NULL;
+error_block * bad_addresses = NULL;
 
-uschar *frozen_by = NULL;
-uschar *queued_by = NULL;
+uschar * frozen_by = NULL, * queued_by = NULL;
 
-uschar *errmsg;
+uschar * errmsg;
 rmark rcvd_log_reset_point;
 gstring * g;
 struct stat statbuf;
 
 /* Final message to give to SMTP caller, and messages from ACLs */
 
-uschar *smtp_reply = NULL;
-uschar *user_msg, *log_msg;
+uschar * smtp_reply = NULL,  * user_msg, * log_msg;
 
 /* Working header pointers */
 
@@ -1808,6 +1797,7 @@ search_tidyup();
 /* Extracting the recipient list from an input file is incompatible with
 cutthrough delivery with the no-spool option.  It shouldn't be possible
 to set up the combination, but just in case kill any ongoing connection. */
+
 if (extract_recip || !smtp_input)
   cancel_cutthrough_connection(TRUE, US"not smtp input");
 
@@ -1815,7 +1805,8 @@ if (extract_recip || !smtp_input)
 header. Temporarily mark it as "old", i.e. not to be used. We keep header_last
 pointing to the end of the chain to make adding headers simple. */
 
-received_header = header_list = header_last = store_get(sizeof(header_line), GET_UNTAINTED);
+received_header = header_list = header_last =
+  store_get(sizeof(header_line), GET_UNTAINTED);
 header_list->next = NULL;
 header_list->type = htype_old;
 header_list->text = NULL;
@@ -1842,11 +1833,7 @@ received_count = 1;            /* For the one we will add */
 
 if (thismessage_size_limit <= 0) thismessage_size_limit = INT_MAX;
 
-/* While reading the message, the following counts are computed. */
-
-message_linecount = body_linecount = body_zerocount =
-  max_received_linelength = 0;
-
+header_from = NULL;
 #ifdef WITH_CONTENT_SCAN
 /* reset non-per-part mime variables */
 mime_is_coverletter    = 0;
@@ -1857,6 +1844,11 @@ mime_part_count        = -1;
 if (misc_mod_msg_init() != OK)
   goto CONN_GONE;
 
+/* While reading the message, the following counts are computed. */
+
+message_linecount = body_linecount = body_zerocount =
+  max_received_linelength = 0;
+
 /* In SMTP sessions we may receive several messages in one connection. Before
 each subsequent one, we wait for the clock to tick at the level of message-id
 granularity.
@@ -2170,7 +2162,7 @@ OVERSIZE:
   beyond it. If it turns out to be a real header, internal binary zeros will
   be squashed later. */
 
-  next->text[ptr] = 0;
+  next->text[ptr] = '\0';
   next->slen = ptr;
   store_release_above(next->text + ptr + 1);
 
@@ -2483,17 +2475,7 @@ for (header_line * h = header_list->next; h; h = h->next)
 
     case htype_from:
       h->type = htype_from;
-#ifdef EXIM_HAVE_DMARC
-      if (!is_resent && !f.dmarc_disable_verify)
-	{
-	misc_module_info * mi = misc_mod_findonly(US"dmarc");
-	if (mi)
-	  {
-	  typedef void (*fn_t)(const uschar *);
-	  (((fn_t *) mi->functions)[DMARC_STORE_FROMHDR]) (h->text);
-	  }
-	}
-#endif
+      if (!is_resent) header_from = h->text;
       if (!resents_exist || is_resent)
 	{
 	from_header = h;

